unit Common;

interface

uses
  Windows, Messages, SysUtils, Classes, IniFiles, RSSysUtils, RSQ, Math;

procedure LoadIni;
function GetOptions: ptr; stdcall;

type
  TSaveSlotFile = array[0..279] of char;
  TSaveSlotFiles = array[0..19] of TSaveSlotFile;
  PSaveSlotFiles = ^TSaveSlotFiles;

const
  _Paused = pint($51D33C);
  _CurrentMember = pint($519350);
  _CurrentScreen = pint($4F37D8);
  _MainMenuCode = pint($6CEB24);
  _CurrentCharScreen = pint($5185A8);
  _NeedRedraw = pint($587ADC);
  _TextGameSaved = ppchar($601E88);
  _ItemInMouse = pint($B7CA64);
  _ActionQueue = ptr($51E330);
  _PartyMembers = $B7CA48;
  _Party_MemberCount = pint($B7CA60);
  _EscKeyUnkCheck = pint($519328);
  _TurnBased = pbool($B21728);
  _CharactersTable = $B2187C;
  _BinkVideo = pptr($FFDE00);
  _SmackVideo = pptr($FFDDA8);
  _AutosaveFile = PPChar($601DDC);
  _AutosaveName = PPChar($601488);
  _QuicksaveFile = PPChar($601FF4);
  _QuicksaveName = PPChar($601FF8);
  _SaveScroll = pint($6CEA74);
  _SaveSlot = pint($6CEA78);
  _SaveSlot2 = pint($6F30C0);
  _SaveSlotsFiles = PSaveSlotFiles($6CADCC);
  _SaveSlotsCount = pint($6CACFC);
  _TextBuffer1 = pchar($5DF0E0);
  _ItemsTxt = $5EFBCC;
  _MainWindow = puint($6F3934);
  _Party_Direction = pint($B21560);
  _Party_Angle = pint($B21564);
  _ScreenW = pint($F01A70);
  _TimeDelta = pint($51D354);
  _Flying = pint($B215A4);
  _MapMonsters = $61C540;
  _IsD3D = pbool($EC1980);
  _startinwindow = pbool($EC1984);

  _DoSaveGame: procedure(n1,unk, autoquick: int) = ptr($45CF27); 
  _DoLoadGame: procedure(n1,n2, slot: int) = ptr($45C906);
  _FindActiveMember: function(n1: int = 0; n2: int = 0; this: int = $B20E90):int = ptr($491A55);
  _ShowStatusText: procedure(a0, seconds: int; text: PChar) = ptr($4496C5);
  _access: function(fileName: PChar; unk: int = 0): int cdecl = ptr($4DC7E5);
  _malloc: function(size:int):ptr cdecl = ptr($4D9F62);
  _new: function(size:int):ptr cdecl = ptr($4D9E0B);
  _PermAlloc: function(n1,n2: int; allocator: ptr; name: PChar; size, unk: int):ptr = ptr($424B4D);
  _PermAllocator = ptr($73F910);
  _LoadMapTrack: procedure = ptr($4AA3E7);
  _ExitScreen: procedure(n1: int = 0; n2: int = 0; a1: int = $1006148; a6: int = 0; a5: int = 0; a4: int = 0; a3: int = 1; a2: int = 27) = ptr($4D1D6A);
  _strcmpi: function(const s1, s2: PChar): int cdecl = ptr($4DA920);

  _LodFind: function(n1, n2, Lod, NoSort: int; Name: PChar): ptr = ptr($45EFFF); 
  _fread: function(var Buf; Size, Count: int; f: ptr): int cdecl = ptr($4DA641);
  _Deflate: procedure(n1: int; UnpSize: pint; var UnpBuf; PkSize: int; var Pk) = ptr($4D1EC0);
  _BitmapsLod = $72DC60;

  _LoadPalette: function(n1, n2, Palettes, PalId: int): int = ptr($489C9F);
  
  _Chest_CanPlaceItem: function(n1, itemType, pos, chest: int): BOOL = ptr($41F293);
  _Chest_PlaceItem: procedure(n1, itemIndex, pos, chest: int) = ptr($41F55E);
  _ChestWidth = $4F3B04;
  _ChestHeight = $4F3B24;

  _Character_GetWeaponDelay: function(n1, n2: int; this:ptr; ranged: LongBool):int = ptr($48D62A);
  _Character_IsAlive: function(a1,a2, member:ptr):Bool = ptr($491514);
  _Character_WearsItem: function(n1,n2:int; this:ptr; id:int):BOOL = ptr($48CFC3);
  _Character_WearsItemWithEnchantSpec: function(n1,n2:int; this:ptr; slot, id:int):BOOL = ptr($48CF8A);
  _Character_GetSkillWithBonuses: function(n1,n2:int; this: ptr; skill: int):int = ptr($48EF4F);

  _ReadRegStr: procedure(_: int; out Buf; Name, Default: PChar; BufSize: int) = ptr($462F28);

  _CharOff_Items = $484;
  _CharOff_ItemMainHand = $1C08;
  _CharOff_ItemBoots = $1C24;
  _CharOff_Recover = $1BF2;
  _CharOff_SpellPoints = $1BFC;
  _CharOff_Size = $1D28;
  
  _ItemOff_Size = $24;

  _MonOff_vx = $9C;
  _MonOff_vy = $9E;
  _MonOff_Size = $3CC;
  
type
  PHwlBitmap = ^THwlBitmap;
  THwlBitmap = packed record
    HwlName: array[1..$14] of byte;
    HwlPalette: int;
    FullW: int;
    FullH: int;
    AreaW: int;
    AreaH: int;
    BufW: int;
    BufH: int;
    AreaX: int;
    AreaY: int;
    Buffer: ptr;
  end;
  TSpriteLine = packed record
    a1: int2;
    a2: int2;
    pos: PChar;
  end;
  PSpriteLines = ^TSpriteLines;
  TSpriteLines = packed array[0..(MaxInt div SizeOf(TSpriteLine) div 2)] of TSpriteLine;

  PSprite = ^TSprite;
  TSprite = packed record
    Name: array[1..12] of char;
    Size: int;
    w: int2;
    h: int2;
    Palette: int2;
    unk_1: int2;
    yskip: int2; // number of clear lines at bottom
    unk_2: int2; // used in runtime only, for bits
    UnpSize: int;
    Lines: PSpriteLines;
    buf: PChar;
  end;

  PSpriteD3D = ^TSpriteD3D;
  TSpriteD3D = packed record
    Name: PChar;
    Pal: int;
    Surface: ptr;
    Texture: ptr;
    AreaX: int;
    AreaY: int;
    BufW: int;
    BufH: int;
    AreaW: int;
    AreaH: int;
  end;

  PLodBitmap = ^TLodBitmap;
  TLodBitmap = packed record
    FileName: array[1..16] of char;
    BmpSize: int;
    DataSize: int;
    w: int2;
    h: int2;
    BmpWidthLn2: int2;  // textures: log2(BmpWidth)
    BmpHeightLn2: int2;  // textures: log2(BmpHeight)
    BmpWidthMinus1: int2;  // textures: BmpWidth - 1
    BmpHeightMinus1: int2;  // textures: BmpHeight - 1
    Palette: int;
    UnpSize: int;
    Bits: int;  // Bits:  2 - multitexture,
    // Data...
    // Palette...
  end;

const
  _SpritesLod = $71EFA8;
  _SpritesOld = _SpritesLod + $23C;
  SpritesMax = 10000;

var
  Sprites: array[0..SpritesMax-1] of TSprite;

const
  SWrong: string = 'this is not a valid mm8.exe file';

type
  TOptions = packed record
    Size: int;
    MaxMLookAngle: int;                // 4
    MouseLook: LongBool;               // 8
    MouseLookUseAltMode: LongBool;     // 12
    CapsLockToggleMouseLook: LongBool; // 16
    MouseFly: LongBool;                // 20
    MouseWheelFly: LongBool;           // 24
    MouseLookTempKey: int;             // 28
    MouseLookChangeKey: int;           // 32
    InventoryKey: int;                 // 36
    CharScreenKey: int;                // 40
    DoubleSpeedKey: int;               // 44
    QuickLoadKey: int;                 // 48
    AutorunKey: int;                   // 52
  end;

var
  Options: TOptions = (
    Size: SizeOf(TOptions);
    MaxMLookAngle: 180;
  );

var
  QuickSavesCount, QuickSaveKey, MusicLoopsCount, MouseBorder,
  StartupCopyrightDelay, HorsemanSpeakTime, BoatmanSpeakTime: int;
  HDWTRCount, HDWTRDelay: uint;

  MLookSpeed, MLookSpeed2: TPoint;

  TurnSpeedNormal, TurnSpeedDouble, PaletteSMul, PaletteVMul: single;

  RecoveryTimeInfo, PlayerNotActive, SDoubleSpeed, SNormalSpeed,
  QuickSaveName, QuickSaveDigitSpace: string;

  CapsLockToggleRun, NoDeathMovie, NoIntro, NoCD, FreeTabInInventory,
  HardenArtifacts, PlayMP3, NoVideoDelays, ReputationNumber,
  ProgressiveDaggerTrippleDamage, FixChests, DataFiles, NoBitmapsHwl,
  AlwaysStrafe, StandardStrafe, MouseLookChanged,
  FixInactivePlayersActing: Boolean;

implementation

procedure LoadIni;
var
  ini, iniOverride: TIniFile;
  sect: string;

  function ReadString(const key, default: string): string;
  begin
    if iniOverride <> nil then
    begin
      Result:= iniOverride.ReadString(sect, key, #13);
      if Result <> #13 then
        exit;
    end;
    Result:= ini.ReadString(sect, key, #13);
    if Result = #13 then
    begin
      ini.WriteString(sect, key, default);
      Result:= default;
    end;
  end;

  function ReadInteger(const key: string; default: int): int;
  begin
    if iniOverride <> nil then
    begin
      Result:= iniOverride.ReadInteger(sect, key, 0);
      if (Result <> 0) or (iniOverride.ReadInteger(sect, key, 1) = 0) then
        exit;
    end;
    Result:= ini.ReadInteger(sect, key, 0);
    if (Result = 0) and (ini.ReadInteger(sect, key, 1) <> 0) then
    begin
      ini.WriteInteger(sect, key, default);
      Result:= default;
    end;
  end;

  function ReadBool(const key: string; default: Boolean): Boolean;
  begin
    Result := ReadInteger(key, Ord(Default)) <> 0;
  end;

  function ReadFloat(const key: string; default: Double): Double;
  var
    old: char;
  begin
    Assert(iniOverride = nil);
    old:= DecimalSeparator;
    DecimalSeparator:= '.';
    Result:= ini.ReadFloat(sect, key, NaN);
    if IsNan(Result) then
    begin
      ini.WriteFloat(sect, key, default);
      Result:= default;
    end;
    DecimalSeparator:= old;
  end;

begin
  iniOverride:= nil;
  ini:= TIniFile.Create(AppPath+'mm8.ini');
  with Options do
    try
      sect:= 'Settings';
      CapsLockToggleRun:= ReadBool('CapsLockToggleRun', false);

      QuickSavesCount:= ReadInteger('QuickSavesCount', 2);
      QuickSaveKey:= ReadInteger('QuickSavesKey', VK_F11);
      if (QuickSaveKey < 0) or (QuickSaveKey > 255) then
        QuickSaveKey:= VK_F11;
      QuickLoadKey:= ReadInteger('QuickLoadKey', 0);

      NoDeathMovie:= ReadBool('NoDeathMovie', false);
      NoIntro:= ReadBool('NoIntro', false);
      NoCD:= ReadBool('NoCD', true);
      InventoryKey:= ReadInteger('InventoryKey', ord('I'));
      CharScreenKey:= ReadInteger('ToggleCharacterScreenKey', 192);
      FreeTabInInventory:= ReadBool('FreeTabInInventory', true);
      HardenArtifacts:= ReadBool('HardenArtifacts', true);
      PlayMP3:= ReadBool('PlayMP3', false);
      MusicLoopsCount:= ReadInteger('MusicLoopsCount', 1);
      NoVideoDelays:= ReadBool('NoVideoDelays', true);
      ReputationNumber:= ReadBool('ReputationNumber', true);
      DoubleSpeedKey:= ReadInteger('DoubleSpeedKey', VK_F2);
      TurnSpeedNormal:= ReadInteger('TurnSpeedNormal', 100)/100;
      TurnSpeedDouble:= ReadInteger('TurnSpeedDouble', 120)/200;
      MouseBorder:= ReadInteger('MouseLookBorder', 100);
      FixChests:= ReadBool('FixChests', true);
      DataFiles:= ReadBool('DataFiles', true);
      NoBitmapsHwl:= ReadBool('NoD3DBitmapHwl', true);
      MouseLook:= ReadBool('MouseLook', false);
      MLookSpeed.X:= ReadInteger('MouseSensitivityX', 35);
      MLookSpeed.Y:= ReadInteger('MouseSensitivityY', 35);
      MLookSpeed2.X:= ReadInteger('MouseSensitivityAltModeX', 75);
      MLookSpeed2.Y:= ReadInteger('MouseSensitivityAltModeY', 75);
      MouseLookChangeKey:= ReadInteger('MouseLookChangeKey', VK_MBUTTON);
      MouseLookTempKey:= ReadInteger('MouseLookTempKey', 0);
      CapsLockToggleMouseLook:= ReadBool('CapsLockToggleMouseLook', true);
      Options.MouseLookUseAltMode:= ReadBool('MouseLookUseAltMode', false);
      MouseFly:= ReadBool('MouseLookFly', true);
      MouseWheelFly:= ReadBool('MouseWheelFly', true);
      AlwaysStrafe:= ReadBool('AlwaysStrafe', false);
      StandardStrafe:= ini.ReadBool(sect, 'StandardStrafe', false);
      PaletteSMul:= ReadFloat('PaletteSMul', 1);
      PaletteVMul:= ReadFloat('PaletteVMul', 1.1);
      StartupCopyrightDelay:= ReadInteger('StartupCopyrightDelay', 5000);
      AutorunKey:= ReadInteger('AutorunKey', VK_F3);
      HDWTRCount:= max(1, min(15, ReadInteger('HDWTRCount', IfThen(NoBitmapsHwl, 8, 7))));
      HDWTRDelay:= max(1, ReadInteger('HDWTRDelay', 20));
      FixInactivePlayersActing:= ini.ReadBool(sect, 'FixInactivePlayersActing', true);

      ini.DeleteKey(sect, 'JumpSpeed');

      iniOverride:= ini;
      ini:= TIniFile.Create(AppPath+'mm8lang.ini');

      QuickSaveName:= ReadString('QuickSavesName', '');
      if ReadBool('SpaceBeforeQuicksaveDigit', false) then
        QuickSaveDigitSpace:= ' ';
      RecoveryTimeInfo:= #10#10 + ReadString('RecoveryTimeInfo', 'Recovery time: %d');
      PlayerNotActive:= ReadString('PlayerNotActive', 'That player in not active');
      SDoubleSpeed:= ReadString('DoubleSpeed', 'Double Speed');
      SNormalSpeed:= ReadString('NormalSpeed', 'Normal Speed');
      HorsemanSpeakTime:= ReadInteger('HorsemanSpeakTime', 1500);
      BoatmanSpeakTime:= ReadInteger('BoatmanSpeakTime', 2500);

    finally
      ini.Free;
      iniOverride.Free;
    end;
end;

function GetOptions: ptr; stdcall;
begin
  Result:= @options;
end;

end.
